diff -uwr source/scripts/engine_tt.cpp 4.0/source/scripts/engine_tt.cpp
--- source/scripts/engine_tt.cpp	2011-09-03 08:29:48.000000000 +0800
+++ 4.0/source/scripts/engine_tt.cpp	2011-10-20 22:43:20.420898400 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Definitions and code related to functions in tt.dll
-	Copyright 2010 Jonathan Wilson, Mark Sararu, Joshua "NeoSaber" Kraft
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -26,7 +25,8 @@
 #include "VehicleGameObj.h"
 #include "SoldierGameObj.h"
 #include "VehicleFactoryGameObj.h"
-
+#include "VehicleFactoryGameObjDef.h"
+#include "AirFactoryGameObj.h"
 class WideStringClass;
 
 
@@ -160,9 +160,9 @@
 		return false;
 	}
 	GameObject *factory = Find_Vehicle_Factory(Team);
-	if (factory && !Is_Building_Dead(factory))
+	if (factory)
 	{
-		return IsAvailableForPurchase(factory);
+		return Is_Available_For_Purchase(factory);
 	}
 	return true;
 }
@@ -737,6 +737,83 @@
 	Set_Special_Base_Destruction();
 }
 
+bool Vehicle_Preset_Is_Air(int preset)
+{
+	DefinitionClass *def = Find_Definition(preset);
+	if (!def)
+	{
+		return false;
+	}
+	if (def->Get_Class_ID() == 12304)
+	{
+		VehicleGameObjDef *def2 = (VehicleGameObjDef *)def;
+		if (def2->Get_Type() == VEHICLE_TYPE_FLYING)
+		{
+			return true;
+		}
+	}
+	return false;
+}
+
+bool SCRIPTS_API Create_Vehicle(const char *Preset_Name,float Delay,GameObject *Owner,int Team)
+{
+	if (Get_Vehicle(Owner))
+	{
+		return false;
+	}
+	int preset = Get_Definition_ID(Preset_Name);
+	BaseControllerClass *base = BaseControllerClass::Find_Base(Team);
+	DefinitionClass *vehicle = Find_Definition(preset);
+	if (!vehicle)
+	{
+		return false;
+	}
+	BuildingGameObj *bg2 = ((BuildingGameObj *)base->Find_Building(BuildingConstants::TYPE_VEHICLE_FACTORY));
+	VehicleFactoryGameObj *vf = 0;
+	if (bg2)
+	{
+		vf = bg2->As_VehicleFactoryGameObj();
+	}
+	if (!vf && !Vehicle_Preset_Is_Air(preset))
+	{
+		return false;
+	}
+	if (vf && ((vf->Is_Destroyed()) || (vf->Is_Busy())))
+	{
+		if ((!Vehicle_Preset_Is_Air(preset)) || (!vf->Get_Definition().Get_Build_Ground_Only()))
+		{
+			return false;
+		}
+	}
+	if (vf && (!Vehicle_Preset_Is_Air(preset) || !vf->Get_Definition().Get_Build_Ground_Only()))
+	{
+		float delay = 5.0;
+		if (!base->Is_Base_Powered())
+		{
+			delay *= Get_Build_Time_Multiplier(Team);
+		}
+		vf->Request_Vehicle(preset,delay,Owner->As_SoldierGameObj());
+	}
+	else
+	{
+		BuildingGameObj *bg = ((BuildingGameObj *)base->Find_Building(BuildingConstants::TYPE_HELIPAD));
+		AirFactoryGameObj *af = 0;
+		if (bg)
+		{
+			af = bg->As_AirFactoryGameObj();
+		}
+		if (af && !af->Is_Destroyed() && !af->Is_Busy() && Vehicle_Preset_Is_Air(preset))
+		{
+			af->Create_Vehicle(preset,Owner->As_SoldierGameObj());
+		}
+		else
+		{
+			return false;
+		}
+	}
+	return true;
+}
+
 SCRIPTS_API REF_DEF2(ConsoleFunctionList,DynamicVectorClass<ConsoleFunctionClass *>,0x0081DEB8,0x0081D098);
 
 RENEGADE_FUNCTION
diff -uwr source/scripts/engine_tt.h 4.0/source/scripts/engine_tt.h
--- source/scripts/engine_tt.h	2011-09-03 08:33:42.000000000 +0800
+++ 4.0/source/scripts/engine_tt.h	2011-10-11 21:53:26.168945300 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Definitions and code related to functions in tt.dll
-	Copyright 2010 Jonathan Wilson, Mark Sararu, Joshua "NeoSaber" Kraft
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_ttdef.h 4.0/source/scripts/engine_ttdef.h
--- source/scripts/engine_ttdef.h	2011-08-30 23:13:42.000000000 +0800
+++ 4.0/source/scripts/engine_ttdef.h	2011-10-11 21:53:21.451171800 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Definitions and code related to functions in tt.dll that are shared with tt.dll
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_vector.h 4.0/source/scripts/engine_vector.h
--- source/scripts/engine_vector.h	2011-03-09 14:10:32.000000000 +0800
+++ 4.0/source/scripts/engine_vector.h	2011-10-12 09:16:51.028320300 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Container classes
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_weap.cpp 4.0/source/scripts/engine_weap.cpp
--- source/scripts/engine_weap.cpp	2011-09-04 17:08:26.000000000 +0800
+++ 4.0/source/scripts/engine_weap.cpp	2011-10-11 23:03:09.419921800 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Weapon related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu, WhiteDragon(MDB)
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -29,6 +28,7 @@
 #include "engine_player.h"
 #include "SoldierGameObj.h"
 #include "engine_weap.h"
+#include "OffenseObjectClass.h"
 #include <limits>
 
 SoldierGameObj* BeaconGameObj::Get_Owner()
@@ -621,7 +621,7 @@
 	return "None";
 }
 
-SCRIPTS_API AmmoDefinitionClass *Get_Weapon_Ammo_Definition(const char *weapon,bool PrimaryFire)
+SCRIPTS_API const AmmoDefinitionClass *Get_Weapon_Ammo_Definition(const char *weapon,bool PrimaryFire)
 {
 	WeaponDefinitionClass *d = (WeaponDefinitionClass *)Find_Named_Definition(weapon);
 	if (d)
@@ -642,7 +642,7 @@
 	return 0;
 }
 
-SCRIPTS_API WeaponDefinitionClass *Get_Current_Weapon_Definition(GameObject *obj)
+SCRIPTS_API const WeaponDefinitionClass *Get_Current_Weapon_Definition(GameObject *obj)
 {
 	if (!obj || !Commands->Get_ID(obj))
 	{
@@ -661,17 +661,17 @@
 	WeaponBagClass *w = o3->Get_Weapon_Bag();
 	if ((w->Get_Index()) && (w->Get_Index() < w->Get_Count()))
 	{
-		return *(WeaponDefinitionClass **)w->Peek_Weapon(w->Get_Index());
+		return w->Peek_Weapon(w->Get_Index())->Get_Definition();
 	}
 	return 0;
 }
 
-SCRIPTS_API WeaponDefinitionClass *Get_Weapon_Definition(const char *weapon)
+SCRIPTS_API const WeaponDefinitionClass *Get_Weapon_Definition(const char *weapon)
 {
 	return (WeaponDefinitionClass *)Find_Named_Definition(weapon);
 }
 
-SCRIPTS_API WeaponDefinitionClass *Get_Position_Weapon_Definition(GameObject *obj,int position)
+SCRIPTS_API const WeaponDefinitionClass *Get_Position_Weapon_Definition(GameObject *obj,int position)
 {
 	if (!obj || !Commands->Get_ID(obj))
 	{
@@ -688,14 +688,14 @@
 		return 0;
 	}
 	WeaponBagClass *w = o3->Get_Weapon_Bag();
-	if ((position < w->Get_Count()) && (w->Peek_Weapon(w->Get_Index())))
+	if ((position) && (position < w->Get_Count()))
 	{
-		return *(WeaponDefinitionClass **)w->Peek_Weapon(w->Get_Index());
+		return w->Peek_Weapon(position)->Get_Definition();
 	}
 	return 0;
 }
 
-SCRIPTS_API ExplosionDefinitionClass *Get_Explosion(const char *explosion)
+SCRIPTS_API const ExplosionDefinitionClass *Get_Explosion(const char *explosion)
 {
 	return (ExplosionDefinitionClass *)Find_Named_Definition(explosion);
 }
@@ -814,7 +814,8 @@
 	{
 		return;
 	}
-	o3->Completely_Damaged(*(OffenseObjectClass *)0);
+	OffenseObjectClass offense(0);
+	o3->Completely_Damaged(offense);
 }
 
 SCRIPTS_API GameObject *Get_Beacon_Planter(GameObject *obj)
@@ -1039,7 +1040,7 @@
 		return 0;
 	}
 	WeaponBagClass *w = o3->Get_Weapon_Bag();
-	if (w->Peek_Weapon(position))
+	if ((position) && (position < w->Get_Count()))
 	{
 		return (w->Peek_Weapon(position)->Get_Name());
 	}
diff -uwr source/scripts/engine_weap.h 4.0/source/scripts/engine_weap.h
--- source/scripts/engine_weap.h	2011-02-18 08:29:48.000000000 +0800
+++ 4.0/source/scripts/engine_weap.h	2011-10-11 21:53:12.073242100 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Weapon related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu, WhiteDragon(MDB)
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -37,11 +36,11 @@
 SCRIPTS_API int Get_Position_Clip_Max_Bullets(GameObject *obj,int position); //Get clip/backpack bullets for an objects gun at a specific position
 //For all of these, -1 means "infinate ammo"
 SCRIPTS_API const char *Get_Powerup_Weapon(const char *Powerup); //Get the weapon name that a powerup will grant if collected
-SCRIPTS_API AmmoDefinitionClass *Get_Weapon_Ammo_Definition(const char *weapon,bool PrimaryFire); //Get the AmmoDefinitionClass of a weapon given its preset name
-SCRIPTS_API WeaponDefinitionClass *Get_Weapon_Definition(const char *weapon); //Get the WeaponDefinitionClass of a weapon given its preset name
-SCRIPTS_API WeaponDefinitionClass *Get_Current_Weapon_Definition(GameObject *obj); //Get the WeaponDefinitionClass of an objects current weapon
-SCRIPTS_API WeaponDefinitionClass *Get_Position_Weapon_Definition(GameObject *obj,int position); //Get the WeaponDefinitionClass of an objects weapon at the specified position
-SCRIPTS_API ExplosionDefinitionClass *Get_Explosion(const char *explosion); //Get the ExplosionDefinitionClass of an explosion given its preset name
+SCRIPTS_API const AmmoDefinitionClass *Get_Weapon_Ammo_Definition(const char *weapon,bool PrimaryFire); //Get the AmmoDefinitionClass of a weapon given its preset name
+SCRIPTS_API const WeaponDefinitionClass *Get_Weapon_Definition(const char *weapon); //Get the WeaponDefinitionClass of a weapon given its preset name
+SCRIPTS_API const WeaponDefinitionClass *Get_Current_Weapon_Definition(GameObject *obj); //Get the WeaponDefinitionClass of an objects current weapon
+SCRIPTS_API const WeaponDefinitionClass *Get_Position_Weapon_Definition(GameObject *obj,int position); //Get the WeaponDefinitionClass of an objects weapon at the specified position
+SCRIPTS_API const ExplosionDefinitionClass *Get_Explosion(const char *explosion); //Get the ExplosionDefinitionClass of an explosion given its preset name
 SCRIPTS_API const char *Get_Powerup_Weapon_By_Obj(GameObject *Powerup); //Get the name of a powerup weapon given a PowerUpGameObj
 SCRIPTS_API int Get_Current_Weapon_Style(GameObject *obj); //Get weapon style for an objects current gun
 SCRIPTS_API int Get_Position_Weapon_Style(GameObject *obj,int position); //Get weapon style for an objects gun at a specific position
diff -uwr source/scripts/gap.cpp 4.0/source/scripts/gap.cpp
--- source/scripts/gap.cpp	2010-09-11 21:22:42.000000000 +0800
+++ 4.0/source/scripts/gap.cpp	2011-10-11 23:04:42.054687500 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Gap Generator scripts
-	Copyright 2010 Joshua "NeoSaber" Kraft, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/gap.h 4.0/source/scripts/gap.h
--- source/scripts/gap.h	2010-04-14 10:13:26.000000000 +0800
+++ 4.0/source/scripts/gap.h	2011-10-14 22:27:32.132812500 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Gap Generator scripts
-	Copyright 2010 Joshua "NeoSaber" Kraft, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class RA_Global_Gap_Controller : public ScriptImpClass {
 	Gap_ListNode *ListHead;
 	void Created(GameObject *obj);
diff -uwr source/scripts/gmbuilding.cpp 4.0/source/scripts/gmbuilding.cpp
--- source/scripts/gmbuilding.cpp	2011-08-21 08:13:58.000000000 +0800
+++ 4.0/source/scripts/gmbuilding.cpp	2011-10-11 23:04:38.933593700 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #include "General.h"
 #include "scripts.h"
 #include "gmbuilding.h"
diff -uwr source/scripts/gmbuilding.h 4.0/source/scripts/gmbuilding.h
--- source/scripts/gmbuilding.h	2011-08-20 13:51:12.000000000 +0800
+++ 4.0/source/scripts/gmbuilding.h	2011-10-11 21:52:47.537109300 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #ifndef TT_INCLUDE_GMBUILDING_H
 #define TT_INCLUDE_GMBUILDING_H
 class SSGM_Building : public ScriptImpClass {
